
-- here, we boil stuff down
if false then
  local data = {
    [[spiral 180
neko 71
red_rabbit 76
researcher 36
yay 91
jack 81
whale 135
nanok 77
crown 175
behave 100]],
[[behave 71
neko 67
yay 59
researcher 39
spiral 35
jack 76
crown 85
whale 62
red_rabbit 64
nanok 41]],
[[whale 100
behave 59
red_rabbit 46
neko 169
crown 50
yay 136
researcher 68
jack 63
nanok 52
spiral 42]],
[[behave 47
crown 187
spiral 148
red_rabbit 65
yay 91
nanok 348
neko 82
researcher 144]],
[[researcher 131
neko 52
red_rabbit 66
spiral 76
behave 59]],}
  local ite = {}
  local itec = {}
  for _, v in pairs(data) do
    for tex in v:gmatch("[^\n]+") do
      local t, w = tex:match("(%w+) (%d+)")
      ite[t] = (ite[t] or 0) + w
      itec[t] = (itec[t] or 0) + 1
    end
  end
  
  for k, v in pairs(ite) do
    print(k, v / itec[k], itec[k])
  end
  
  assert(false)
end

local klok_pos = 0
do
  local bg = CreateFrame("Sprite")
  bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
  bg:SetTexture("hoose")
  bg:SetLayer(-1000)
  
  local cloc
  cloc = CreateFrame("Sprite")
  cloc:SetLayer(20)
  cloc:SetTexture("clock")
  cloc:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", 980, 760)
  
  local klok_hands = CreateFrame("Sprite", cloc)
  klok_hands:SetWidth(160)
  klok_hands:SetHeight(klok_hands:GetWidth())
  klok_hands:SetPoint("CENTER", cloc, "CENTER", 0, -7)
  function klok_hands:Draw()
    local sx, sy, ex, ey = self:GetBounds()
    local mx, my = (sx + ex) / 2, (sy + ey) / 2
    local daxis = mx - sx
    
    gl.LineWidth(1)
    gl.Enable("LINE_SMOOTH")
  
    gl.Color(0.4, 0.4, 0.3)
    
    gl.Begin("LINES")
    for i = 1, 30 do
      gl.Vertex(mx + math.sin(i / 30 * 3.14159 * 2) * daxis * 0.60, my + math.cos(i / 30 * 3.14159 * 2) * daxis * 0.65)
      gl.Vertex(mx + math.sin(i / 30 * 3.14159 * 2) * daxis * 0.70, my + math.cos(i / 30 * 3.14159 * 2) * daxis * 0.65)
    end
    gl.End()
    
    gl.LineWidth(3)
    
    gl.Color(0.7, 0.7, 0.6)
    gl.Begin("LINES")
    gl.Vertex(mx, my)
    gl.Vertex(mx + math.cos(klok_pos * 3.14159 * 2 - 3.14159 / 2) * daxis * 0.8, my + math.sin(klok_pos * 3.14159 * 2 - 3.14159 / 2) * daxis * 0.8)
    gl.End()
  end
end

math.randomseed(os.time())

local maps = {
  -- andre
  {"behave", 45, 67}, -- 35
  --{"behave", 2}, -- 35
  {"yay", 45, 94},  -- 35
  
  -- copperman
  {"red_rabbit", 50, 64}, -- 40
  {"neko", 30, 88}, -- 20
  
  -- picture panic
  {"crown", 25, 124}, -- 15
  {"jack", 30, 73}, -- 20
  
  -- mandible
  {"nanok", 30, 130}, -- 20
  {"researcher", 25, 84}, -- 20
  
  -- null
  {"spiral", 15, 96}, -- 8
  {"whale", 35, 99}, -- 25
}

local score_thresh = {
  {25, "A+", {"Sublime!", "Spectacular.", "So original!", "It reminds me of the canals of Venice."}},
  {50, "A", {"Wonderful!", "Excellent!", "It's beautiful.", "It reminds me of the boulevards of Paris."}},
  {100, "B", {"Intriuging.", "Interesting.", "It's quite pretty.", "It reminds me of the skyline of New York City."}},
  {200, "C", {"Tolerable.", "Acceptable.", "I suppose I can live with it.", "It reminds me of the ports of Seattle."}},
  {500, "D", {"Terrible.", "Ugly.", "Have you even seen art?", "It reminds me of the alleys of Moscow."}},
  {10000, "F", {"Atrocious.", "Derivative.", "Utterly without merit.", "It reminds me of the sewers of Mumbai."}},
}

do
  local function drawbetween(points, st, nd, reflex)
    local tex = Texture("spot")
    local teex = tex:GetWidth() / tex:GetInternalWidth()
    local teey = tex:GetHeight() / tex:GetInternalHeight()
    local xadj = 1 / tex:GetInternalWidth() / 2
    local yadj = 1 / tex:GetInternalHeight() / 2
    
    tex:SetTexture()
    gl.Begin("QUADS")
    for i = st, nd do
      local v = points[i]
      gl.TexCoord(0 + xadj, 0 + yadj)
      gl.Vertex(v.x - 6, v.y - 6)
      gl.TexCoord(teex + xadj, 0 + yadj)
      gl.Vertex(v.x + 6, v.y - 6)
      gl.TexCoord(teex + xadj, teey + yadj)
      gl.Vertex(v.x + 6, v.y + 6)
      gl.TexCoord(0 + xadj, teey + yadj)
      gl.Vertex(v.x - 6, v.y + 6)
      points[i].dclust = reflex
    end
    gl.End()
    SetNoTexture()
  end
  function pl_draw(self)
    gl.Color(1, 1, 1, self.opaci)
    for i = 1, #self.points / 100 do
      if not self.pointclust[i] then
        local lst = List()
        lst:Create()
        
        drawbetween(self.points, i * 100 - 99, i * 100, i)
        
        lst:End()
        self.pointclust[i] = lst
      end
      
      self.pointclust[i]:Call()
    end
    
    drawbetween(self.points, #self.pointclust * 100 + 1, #self.points)
  end
  
  
  local function pl_addpoint(self, x, y)
    for _, p in ipairs(self.points) do
      local dx, dy = x - p.x, y - p.y
      dx, dy = dx * dx, dy * dy
      if dx + dy <= 25 then return end
    end
    
    table.insert(self.points, {x = x, y = y})
    
    self:Update(self.points[#self.points])
  end
  
  local function pl_cache_update(self, ite)
    if ite.cluster then ite.cluster[ite] = nil end
    
    local xc, yc = math.floor(ite.x / 16), math.floor(ite.y / 16)
    if not self.clusts[xc] then self.clusts[xc] = {} end
    if not self.clusts[xc][yc] then self.clusts[xc][yc] = {} end
    ite.cluster = self.clusts[xc][yc]
    ite.cluster[ite] = true
    if ite.dclust then self.pointclust[ite.dclust] = nil end
  end
  local function pl_cache_find_closest(self, x, y)
    local xc, yc = math.floor(x / 16), math.floor(y / 16)
    
    local closest = 64 * 64
    local cite = nil
    for i = 0, 4 do
      if ((i - 1) * 16) * ((i - 1) * 16) > closest then break end
      
      for tx = -i, i do
        if not self.clusts[xc + tx] then continue end
        
        for ty = -i, i do
          if math.abs(tx) ~= i and math.abs(ty) ~= i then continue end
          
          if not self.clusts[xc + tx][yc + ty] then continue end
          
          for nod in pairs(self.clusts[xc + tx][yc + ty]) do
            local dx, dy = nod.x - x, nod.y - y
            local d = dx * dx + dy * dy
            if d < closest then
              closest = d
              cite = nod
            end
          end
        end
      end
    end
    
    return closest, cite
  end
  
  local function pl_write(self)
    local fil = io.open("dump.lua", "w")
    fil:write("return {")
    for _, v in pairs(self.points) do
      fil:write(("{x=%d,y=%d},"):format(v.x, v.y))
    end
    fil:write("}")
    fil:close()
  end
  local function pl_read(self, map)
    self.points = loadfile("image_" .. map .. ".lua")()
    self.pointclust = {}
    
    for _, v in pairs(self.points) do
      self:Update(v)
    end
  end

  function MakePointlayer(frame, opaci)
    frame.points = {}
    frame.pointclust = {}
    frame.clusts = {}
    frame.opaci = opaci
    frame.Draw = pl_draw
    frame.AddPoint = pl_addpoint
    frame.Write = pl_write
    frame.Read = pl_read
    frame.Update = pl_cache_update
    frame.Nearest = pl_cache_find_closest
    return frame
  end
end


local deeppoint
local vaguepoint

local function score_direct(a, b)
  if a.points == 0 then return 5000 end
  
  local acum = 0
  for _, v in pairs(a.points) do
    acum = acum + b:Nearest(v.x, v.y)
  end
  
  return acum / #a.points
end

local function score(a, b)
  local x, y = score_direct(a, b), score_direct(b, a)
  print("SCORE:", x + y, x, y)
  return x + y
end

local allow_draw = false

--local doompfile = io.open("c:\\copperman_dumptest_" .. os.time() .. ".txt", "w")
--assert(doompfile)

local function get_score(sco)
  local skore = nil
  for i = 1, #score_thresh do
    skore = score_thresh[i]
    if score_thresh[i][1] >= sco then break end
  end
  return skore
end

local function do_some_challenges(set, count)
  local avail_lev = {}
  for _, v in ipairs(maps) do
    if set[v[1]] then
      table.insert(avail_lev, v)
    end
  end
  
  local order = {}
  for i = 1, count do
    table.insert(order, table.remove(avail_lev, math.random(#avail_lev)))
  end
  
  --local order = avail_lev
  
  local totscore = 0
  
  for _, tab in ipairs(order) do
    set[tab[1]] = nil
    
    local canvas_anchor = CreateFrame("Frame")
    canvas_anchor:SetWidth(1024)
    canvas_anchor:SetHeight(768)
    canvas_anchor:SetPoint("CENTER", UIParent, "CENTER")
    canvas_anchor:SetCoordinateScale(0, 0, 1024, 0)
    
    local canvas = CreateFrame("Frame", canvas_anchor)
    canvas:SetWidth(920)
    canvas:SetHeight(670)
    canvas:SetPoint("CENTER", UIParent, "TOPLEFT")
    canvas:SetBackgroundColor(1, 1, 1)
    
    local canvasframe = CreateFrame("Sprite", canvas)
    canvasframe:SetTexture("canvas")
    canvasframe:SetPoint("CENTER", canvas, "CENTER")
    
    local drawframe = CreateFrame("Frame", canvas)
    drawframe:SetAllPoints()
    drawframe:SetCoordinateScale(512, 384, 920, 0)

    deeppoint = MakePointlayer(CreateFrame("Frame", drawframe), 0.7)
    vaguepoint = MakePointlayer(CreateFrame("Frame", drawframe), 0.05)
    vaguepoint:Read(tab[1])
    
    -- we do bouncing or some shit like that
    local cy = -500
    local dy = -5
    while cy ~= 0 or dy ~= 0 do
      cy = cy - dy
      dy = dy - 2
      if cy > 0 then
        PlaySound("wood")
        cy = 0
        dy = dy * -0.4
        if math.abs(dy) < 8 then
          dy = 0
        end
      end
      canvas_anchor:SetCoordinateScale(0, -cy, 1024, 0)
      print(cy, dy)
      coroutine.yield()
    end
    
    allow_draw = true
    for i = 1, tab[2] do
      klok_pos = i / tab[2]
      coroutine.pause(60)
      if i ~= tab[2] then PlaySound("tick") end
    end
    allow_draw = false
    
    local sco = score(deeppoint, vaguepoint) / tab[3] * 75
    
    totscore = totscore + sco
    
    --doompfile:write(("%s %d\n"):format(tab[1], sco))
    
    print("Scored:", sco)
    
    local skore = get_score(sco)
    
    local tex = skore[3][math.random(#skore[3])]
    
    local balewn = CreateFrame("Sprite")
    balewn:SetTexture("speex")
    balewn:SetLayer(1)
    balewn:SetPoint("CENTER", UIParent, "TOPLEFT", 700, 400)
    local texf = CreateFrame("Text_Multiline", balewn)
    texf:SetPoint("CENTER", balewn, "CENTER")
    texf:SetWidth(340)
    texf:SetHeight(150)
    texf:SetText("\1J0C000000ffS1.5\1" .. tex)
    
    local cred = CreateFrame("Sprite", drawframe)
    cred:SetTexture("grade_" .. skore[2]:lower())
    cred:SetLayer(100)
    
    PlaySound("stamp")
    
    cred:SetWidth(cred:GetWidth() * 2)
    cred:SetHeight(cred:GetHeight() * 2)
    for i = 1, 4 do
      cred:SetPoint("CENTER", UIParent, "TOPLEFT", 150 + math.random(-50, 50), 150 + math.random(-50, 50))
      coroutine.pause(5)
    end
    
    cred:SetWidth(cred:GetWidth() / 2)
    cred:SetHeight(cred:GetHeight() / 2)
    for i = 1, 4 do
      cred:SetPoint("CENTER", UIParent, "TOPLEFT", 150 + math.random(-25, 25), 150 + math.random(-25, 25))
      coroutine.pause(5)
    end
    
    cred:SetPoint("CENTER", UIParent, "TOPLEFT", 150, 150)
    
    coroutine.pause(80)
    
    -- yyyyoink
    local ang = 0
    local gang = 30
    local ang_apr = 0.03
    
    local x, y = 0, 0
    local dx, dy = 0, 10
    local ddx = -1
    for i = 1, 120 do
      ang = (ang * (1 - ang_apr)) + gang * ang_apr
      x, y = x + dx, y + dy
      dx = dx + ddx
      
      canvas_anchor:SetCoordinateScale(x, y, 1024, ang)
      coroutine.yield()
    end
    
    balewn:Detach()
    canvas_anchor:Detach()
  end
  
  return totscore
end

local text = {
  {
    -- pre-first
    "Oh, what a beautiful day it is today.",
    "This finest of days. Why, it almost inspires me . . .",
    "to do art!",
    "Almost.",
    "Unfortunate, really, that I have no imagination at all.",
    "But hark! I hear a customer approaching!",
    "Quick, to my studio!",
    "The bills must be paid, so instead of creating my own art . . .",
    ". . . I shall copy the art of others!",
    "I must be careful, but work quickly,",
    "for I have not much time before the customer arrives.",
    "The more precisely I copy, the more valuable he shall believe my art to be!",
  },
  {
    -- gain arrow keys
    "Whew! This is hard work.",
    "But I feel . . . stronger, somehow. I feel like I have power over the ink itself!",
    "In fact, I feel like I could . . .",
    "\1Cff0000ff\1Use the arrow keys to move misplaced lines!",
    "More customers! Quick, to work!"
  },
  {
    -- gain spacebar
    "My skills of forgery grow ever stronger!",
    "I feel like I could bend the ink to move \1I\1itself\1/I\1!",
    "\1Cff0000ff\1Use the spacebar to force things into the right place!",
    "Now, time for my masterpiece!",
    "Copied from someone else's masterpiece!",
  },
  {
    -- endgame
    "Ah, how exhilirating! I am truly a noteworthy artist.",
    "Perhaps someday I will even draw something of my own.",
    ". . . Nah.",
    "For now, to rest! I have done great work today.",
    "Let me see how learned I have become.",
  },
}

local score = {
  ["A+"] = {"Masterful! I am a genius!"},
  ["A"] = {"I am truly a wonderful artist. Sales don't lie!"},
  ["B"] = {"Well, it pays the bills. That's what art is about."},
  ["C"] = {"Perhaps I could use some practice. Practice at copying."},
  ["D"] = {"How can I pass off this art as mine when I cannot even follow its lines!"},
  ["F"] = {"I would almost be better off trying to create my own art!"},
}

local function play_text(tex)
  local balewn = CreateFrame("Sprite")
  balewn:SetTexture("speex_me")
  balewn:SetLayer(1500) -- hee
  balewn:SetPoint("CENTER", UIParent, "TOPLEFT", 300, 500)
  local texf = CreateFrame("Text_Multiline", balewn)
  texf:SetPoint("CENTER", balewn, "CENTER")
  texf:SetWidth(340)
  texf:SetHeight(180)
  
  for _, v in pairs(tex) do
    PlaySound("toot", 0.5)
    texf:SetText("\1J0C000000ffS1.4\1" .. v)
    coroutine.yield()
    
    while not (WasKeyPressed("mouse_left") or WasKeyPressed("space") or WasKeyPressed("mouse_right")) do
      coroutine.yield()
    end
    
    if WasKeyPressed("mouse_right") then break end
  end
  
  balewn:Detach()
end

local gamepath = coroutine.wrap(function ()
  PlaySound("start_clink")
  
  local scores = {}
  
  local items = {}
  items.spiral = true
  items.crown = true
  items.jack = true
  items.neko = true
  
  coroutine.pause(60)
  
  play_text(text[1])

  table.insert(scores, do_some_challenges(items, 2))
  
  items.spiral = nil
  items.crown = nil
  items.nanok = true
  items.whale = true
  items.yay = true
  items.researcher = true
  
  play_text(text[2])
  enable_move = true
  
  table.insert(scores, do_some_challenges(items, 2))
  
  items.neko = nil
  items.jack = nil
  items.behave = true
  items.red_rabbit = true
  
  play_text(text[3])
  enable_shift = true
  
  table.insert(scores, do_some_challenges(items, 2))
  
  play_text(text[4])
  
  local texts = {"Learning Art", "Practicing Art", "Mastering Art"}
  
  local scoreframe = CreateFrame("Frame")
  scoreframe:SetLayer(50)
  
  local scorebg = CreateFrame("Frame", scoreframe)
  scorebg:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
  scorebg:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
  scorebg:SetBackgroundColor(1, 1, 1, 0.8)
  scorebg:SetLayer(-1)
  
  
  scoreframe:SetPoint("BOTTOM", UIParent, "TOP")
  
  local last_tier = scoreframe
  
  local all_ap = true
  
  local tscore = 0
  for k, v in ipairs(scores) do
    tscore = tscore + v
    local scod = get_score(v / 2)
    
    local scf = CreateFrame("Frame", scoreframe)
    scf:SetPoint("TOP", last_tier, "BOTTOM", nil, 50)
    scf:SetPoint(0.5, nil, UIParent, 0.5, nil)
    scf:SetHeight(100)
    scf:SetWidth(600)
    
    local tex = CreateFrame("Text", scf)
    tex:SetPoint(0, 0.5, scf, 0, 0.5)
    tex:SetText(texts[k])
    tex:SetColor(0, 0, 0)
    tex:SetSize(50)
    
    if scod[2] ~= "A+" then all_ap = false end
    
    local signia = CreateFrame("Sprite", scf)
    signia:SetPoint(0.5, 0.5, scf, 1, 0.5)
    signia:SetTexture("grade_" .. scod[2]:lower())
    signia:SetWidth(signia:GetWidth() / 2)
    signia:SetHeight(signia:GetHeight() / 2)
    
    last_tier = scf
  end
  
  local fscore = get_score(tscore / 6)
  
  local scf = CreateFrame("Frame", scoreframe)
  scf:SetPoint("TOP", last_tier, "BOTTOM", nil, 120)
  scf:SetPoint(0.5, nil, UIParent, 0.5, nil)
  scf:SetHeight(100)
  scf:SetWidth(600)
  
  local tex = CreateFrame("Text", scf)
  tex:SetPoint(0, 0.5, scf, 0, 0.5)
  tex:SetText("Total")
  tex:SetColor(0, 0, 0)
  tex:SetSize(80)
  
  local fin = fscore[2]
  if fin == "A+" and all_ap == false then fin = "A" end
  
  local signia = CreateFrame("Sprite", scf)
  signia:SetPoint(0.5, 0.5, scf, 1, 0.5)
  signia:SetTexture("grade_" .. fin:lower())
  
  
  coroutine.pause(60)
  while not (WasKeyPressed("mouse_left") or WasKeyPressed("space")) do
    coroutine.yield()
  end
  
  play_text(score[fin])
  
  --doompfile:close()
  GlorpController("exit_game")
end)

local mx, my = nil, nil

local function do_canvas_path(x, y)
  local dx, dy = x - mx, y - my
  if dx == 0 and dy == 0 then return end  -- no
  
  local sx, sy, sct
  if math.abs(dx) > math.abs(dy) then
    sx = dx / math.abs(dx)
    sy = dy / math.abs(dx)
    sct = dx / sx
  else
    sy = dy / math.abs(dy)
    sx = dx / math.abs(dy)
    sct = dy / sy
  end
  
  for i = 1, sct do
    mx = mx + sx
    my = my + sy
    deeppoint:AddPoint(mx, my)
  end
end

local shiftspeed = 0.5
local accumspeed = 0.1

local splush = 100

local function domove(x, y, funk)
  local splooosh = splush * splush
  for _, p in pairs(deeppoint.points) do
    local dx, dy = x - p.x, y - p.y
    dx, dy = dx * dx, dy * dy
    local d = dx + dy
    if d < splooosh then
      local weight = 1 - math.sqrt(d) / splush
      funk(p, weight)
      deeppoint:Update(p)
    end
  end
end

local function doshift(x, y, sx, sy)
  domove(x, y, function (nod, weight)
    nod.x = nod.x + sx * weight * shiftspeed
    nod.y = nod.y + sy * weight * shiftspeed
  end)
end

local function doaccum(x, y)
  domove(x, y, function (nod, weight)
    local _, clon = vaguepoint:Nearest(nod.x, nod.y)
    if clon then
      local cdx, cdy = clon.x - nod.x, clon.y - nod.y
      
      if cdx ~= 0 or cdy ~= 0 then
        local d = math.sqrt(cdx * cdx + cdy * cdy)
        cdx, cdy = cdx / d, cdy / d
        
        nod.x = nod.x + cdx * weight * accumspeed
        nod.y = nod.y + cdy * weight * accumspeed
      end
    end
  end)
end

local writing_handle = nil
local function done_writing()
  if writing_handle then writing_handle:Stop() end
  writing_handle = nil
end

local shift_handle = nil
local function start_shift()
  if not shift_handle then
    shift_handle = ControlSound("shift", nil, true)
  end
end

local function done_shift()
  if shift_handle then shift_handle:Stop() end
  shift_handle = nil
end

function tick_loop(...)
  gamepath()
  local shifting = false
  
  if allow_draw then
    if mx and my then
      do_canvas_path(GetMouseX(), GetMouseY())
    end
    
    if not IsKeyDownFrame("mouse_left") then
      if enable_move then
        local shiftx, shifty = 0, 0
        if IsKeyDownFrame("arrow_up") or IsKeyDownFrame("w") then
          shifty = shifty - 1
        end
        if IsKeyDownFrame("arrow_down") or IsKeyDownFrame("s") then
          shifty = shifty + 1
        end
        if IsKeyDownFrame("arrow_left") or IsKeyDownFrame("a") then
          shiftx = shiftx - 1
        end
        if IsKeyDownFrame("arrow_right") or IsKeyDownFrame("d") then
          shiftx = shiftx + 1
        end
        if shiftx ~= 0 or shifty ~= 0 then
          shifting = true
          local dst = math.sqrt(shiftx * shiftx + shifty * shifty)
          shiftx, shifty = shiftx / dst, shifty / dst
          doshift(GetMouseX(), GetMouseY(), shiftx, shifty)
        end
      end
      
      if enable_shift then
        if IsKeyDownFrame(" ") then
          shifting = true
          doaccum(GetMouseX(), GetMouseY())
        end
      end
    end
  else
    mx, my = nil, nil
    done_writing()
  end
  
  if shifting then
    start_shift()
  else
    done_shift()
  end
end
function render(...)
end
function key(button, ascii, event)
  if allow_draw then
    if button == "mouse_left" and event == "press" then
      mx, my = GetMouseX(), GetMouseY()
      deeppoint:AddPoint(mx, my)
      writing_handle = ControlSound("chalk", nil, true)
    elseif button == "mouse_left" and event == "release" and mx and my then
      do_canvas_path(GetMouseX(), GetMouseY())
      mx, my = nil, nil
      done_writing()
    --[[elseif button == "z" and event == "press" then
      deeppoint:Write()
    elseif button == "x" and event == "press" then
      score(deeppoint, vaguepoint)]]
    end
  end
end
-- think there's more